#
# wu-ftpd Spec File
#
%define name	wu-ftpd
%define	ver	2.6.2
%define rel	1.1ml

Summary: Washington University FTP daemon
Name: %{name}
Version: %{ver}
Release: %{rel}
Copyright: BSDish, see LICENSE
Group: Server/FTP
Source: ftp://ftp.wu-ftpd.org/pub/wu-ftpd/wu-ftpd-%{ver}.tar.gz
Source1: ftp.pamd
Source2: ftpd.logrotate.conf
## Official pathes
Patch0: ftp://ftp.wu-ftpd.org/pub/wu-ftpd/patches/apply_to_2.6.2/connect-dos.patch
Patch1: ftp://ftp.wu-ftpd.org/pub/wu-ftpd/patches/apply_to_2.6.2/realpath.patch

Patch4: wu-ftpd-2.6.0-tlconfig.patch
Patch5: wu-ftpd-2.4.2-ps.patch
Patch7: wu-ftpd-pathsum.patch
Patch8: wu-ftpd-2.6.1-noroot.patch
Patch9: wu-ftpd-2.6.0-Makefile.etc.patch

Requires: pam >= 0.59
Provides: ftpserver
Prereq: fileutils
BuildRoot: /var/tmp/%{name}-%{ver}-root
Serial: 2003081501

%description
wu-ftpd is the daemon (background) program which serves FTP files to
ftp clients.  It is useful if you wish to exchange programs between
computers without running a network filesystem such as NFS, or if you
with to run an anonymous FTP site (in which case, you will want to
install the anonftp package).

%changelog
* Fri Aug 15 2003 Hideo Takeuchi <takeuchi@miraclelinux.com>
- upgraded to 2.6.2-1
- Security fixed (CAN-2003-0466)
- description change of ftpusers in a ftp.pamd file

* Thu Nov 29 2001 Yasuma Takeda <yasuma@miraclelinux.com>
- security update of globbing heap corruption vulnerability

* Thu Mar 14 2001 Mike Madore <mmadore@turbolinux.com>
- Fixed missing_format_strings patch (wouldn't apply cleanly)
- libtoolized build for ia64

* Thu Feb 08 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Added offical patches.

* Wed Nov 29 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Modified src/dataconn.h in wu-ftpd-2.6.1.test.patch.

* Thu Nov 09 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Fix patch is updated from http://www.isoternet.org/~y-koga/wu-ftpd/

* Wed Aug 23 2000 SL Baur  <steve@turbolinux.co.jp>
- destackguard, fix for rpm-4

* Mon Aug 14 2000 KC M <kcm@turbolinux.co.jp>
- change cksum/md5sum path

* Fri Jul 28 2000 KC M <kcm@turbolinux.co.jp>
- fix patches: http://www.isoternet.org/~y-koga/wu-ftpd/

* Thu Jul 27 2000 KC M <kcm@turbolinux.co.jp>
- 2.6.1

* Wed Jun 28 2000 KC M <kcm@turbolinux.co.jp>
- remove 'SITE EXEC' patch
- add official lreply-buffer-overflow.patch

* Fri Jun 23 2000 KC M <kcm@turbolinux.co.jp>
- fix 'SITE EXEC' security vulnerability

* Wed May 24 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Comment out %postun section.

* Wed Mar 29 2000 Takeshi Aihana <takeshi@turbolinux.co.jp>
- rebuild with gcc SG

* Thu Nov 25 1999 KC M <kcm@turbolinux.co.jp>
- added symlink /etc/ftpd to /etc/wu-ftpd

* Tue Oct 19 1999 Roger Luethi <rluethi@turbolinux.com>
- Upgrade to 2.6.0

* Tue Oct 6 1999 Roger Luethi <rluethi@turbolinux.com>
- moved ftpd config files from /etc/ to /etc/wu-ftpd/
- renamed config files for logrotate.d from ftp to wu-ftpd
  (doesn't work for pam.d, the name must be ftp)
- added conf line "greeting brief" to tlconfig/ftpaccess, which meant
  replacing the old wu-ftpd-2.4.2-tlconfig.patch with
  wu-ftpd-2.6.0-tlconfig.patch

* Tue Sep 28 1999 Roger Luethi <rluethi@turbolinux.com>
- upgraded to wu-ftpd-2.6.0pre4
- renamed patch from Makefile.etc.patch to wu-ftpd-2.6.0-Makefile.etc.patch

* Mon Sep 27 1999 Roger Luethi <rluethi@turbolinux.com>
- moved man page tree from /usr/man to /usr/share/man

* Thu Sep 23 1999 Roger Luethi <rluethi@turbolinux.com>
- updated to 2.6.0pre3 (primarily fixes to autoconf build system)
- moved to autoconf build
- fixed copyright field
- changed name of source file ftpd.log to ftpd.logrotate.conf
- support for RPM_BUILD_ROOT added
- moved ftpd config files from /etc/ to /etc/ftpd/
- added patch Makefile.etc.patch to force install with a new Makefile
  (the /etc paths goes in the binaries; the current Makefile doesn't let
  you install to a different path)
- new binaries (ftprestart, ckconfig) + man page (ftprestart)

* Mon Sep 20 1999 Troy D. Gillette <tgillette@turbolinux.com>
- moved to 2.6.0pre2 to fix a message buffer overrun

* Tue Feb 02 1999 Kelley Spoon <kspoon@pht.com>
- added patch to make sure the source include asm/types.h

* Fri Dec 12 1997 Cristian Gafton <gafton@redhat.com>
- added a patch to prevent a possible PORT command exploit
- cleaned up the .linux patch to get a clean compile on glibc

* Tue Oct 21 1997 Erik Troan <ewt@redhat.com>
- fixed copyright field

* Mon Oct 13 1997 Michael K. Johnson <johnsonm@redhat.com>
- Updated to new pam conventions.

* Mon Sep 22 1997 Erik Troan <ewt@redhat.com>
- Updated to beta 15, which fixes a number of security holes. Release 1
  if for RH 4.2, release 2 is glibc based.

* Mon Mar 03 1997 Michael K. Johnson <johnsonm@redhat.com>
- Moved from pam.conf to pam.d

* Mon Mar 03 1997 Erik Troan <ewt@redhat.com>
- xferstats should look for perl in /usr/bin, not /usr/local/bin
- provides the "ftpserver" virtual package

* Thu Feb 13 1997 Michael K. Johnson <johnsonm@redhat.com>
- Updated to beta-12, and created a new PAM patch from scratch, since
  the old one made massive changes to ftpd and caused some problems.

%prep
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}/usr/bin
mkdir -p ${RPM_BUILD_ROOT}/etc/wu-ftpd
mkdir -p ${RPM_BUILD_ROOT}/etc/logrotate.d
mkdir -p ${RPM_BUILD_ROOT}/etc/pam.d
mkdir -p ${RPM_BUILD_ROOT}/usr/share/man/man1
mkdir -p ${RPM_BUILD_ROOT}/usr/share/man/man5
mkdir -p ${RPM_BUILD_ROOT}/usr/share/man/man8

%setup -q
%patch0 -p0
%patch1 -p0

mkdir tlconfig
%patch4 -p1 -b .tlconfig
%patch5 -p1 -b .ps
%patch7 -p1 -b .sum
%patch8 -p1 -b .noroot
sed 's/\/usr\/local\/bin\/perl/\/usr\/bin\/perl/g' util/xferstats > util/xferstats.new
mv -f util/xferstats.new util/xferstats
#find ./ -type f -size 0 | xargs rm -f

%ifarch ia64
libtoolize --copy --force
%endif

%build
autoconf
CFLAGS="$RPM_OPT_FLAGS" ./configure \
	--prefix=%{_prefix} --mandir=%{_mandir} \
	--with-etc-dir=/etc/wu-ftpd \
	--enable-nlst-dirs --enable-pam --enable-badclients
make

%install
#./configure --prefix=$RPM_BUILD_ROOT/usr --with-etc-dir=${RPM_BUILD_ROOT}/etc/wu-ftpd --enable-pam
patch < %{PATCH9}
make DESTDIR=${RPM_BUILD_ROOT} install
install -m755 util/xferstats ${RPM_BUILD_ROOT}/usr/sbin
cd tlconfig
install -m600 ftpaccess ${RPM_BUILD_ROOT}/etc/wu-ftpd
install -m600 ftpusers ${RPM_BUILD_ROOT}/etc/wu-ftpd
install -m600 ftphosts ${RPM_BUILD_ROOT}/etc/wu-ftpd
install -m600 ftpgroups ${RPM_BUILD_ROOT}/etc/wu-ftpd
install -m600 ftpconversions ${RPM_BUILD_ROOT}/etc/wu-ftpd

strip ${RPM_BUILD_ROOT}/usr/bin/ftpcount
strip ${RPM_BUILD_ROOT}/usr/bin/ftpwho
strip ${RPM_BUILD_ROOT}/usr/sbin/ckconfig
strip ${RPM_BUILD_ROOT}/usr/sbin/ftprestart
strip ${RPM_BUILD_ROOT}/usr/sbin/ftpshut
strip ${RPM_BUILD_ROOT}/usr/sbin/in.ftpd

install -m 644 %{SOURCE2} ${RPM_BUILD_ROOT}/etc/logrotate.d/wu-ftpd
install -m 644 %{SOURCE1} ${RPM_BUILD_ROOT}/etc/pam.d/ftp

%post
if [ ! -f /var/log/xferlog ]; then
	touch /var/log/xferlog
	chmod 600 /var/log/xferlog
fi
rm -f /etc/ftpd
ln -fs /etc/wu-ftpd /etc/ftpd

#%postun
#rmdir /etc/wu-ftpd

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc CHANGES CONTRIBUTORS COPYRIGHT ERRATA INSTALL LICENSE README*
%doc doc/TODO
%doc doc/HOWTO
%doc doc/misc
%doc doc/examples

/usr/bin/ftpcount
/usr/bin/ftpwho
/usr/sbin/ckconfig
/usr/sbin/ftprestart
/usr/sbin/ftpshut
/usr/sbin/in.ftpd
/usr/sbin/xferstats

/usr/share/man/man8/ftpshut.8*
/usr/share/man/man8/ftpd.8*
/usr/share/man/man8/ftprestart.8*
/usr/share/man/man5/xferlog.5*
/usr/share/man/man5/ftphosts.5*
/usr/share/man/man5/ftpconversions.5*
/usr/share/man/man5/ftpaccess.5*
/usr/share/man/man1/ftpwho.1*
/usr/share/man/man1/ftpcount.1*

%config(noreplace) /etc/wu-ftpd/ftpusers
%config(noreplace) /etc/wu-ftpd/ftphosts
%config(noreplace) /etc/wu-ftpd/ftpgroups
%config(noreplace) /etc/wu-ftpd/ftpconversions
%config(noreplace) /etc/wu-ftpd/ftpaccess
%dir /etc/wu-ftpd

%config(noreplace) /etc/pam.d/ftp
%config(noreplace) /etc/logrotate.d/wu-ftpd
